'Imports Application = Intergraph.GeoMedia.GeoMedia.Application
'Imports MapWindow = Intergraph.GeoMedia.GeoMedia.MapWindow
'Imports Windows = Intergraph.GeoMedia.GeoMedia.Windows
Public Class Funcions
   
    ''' Retorna noms el nom de l'arxiu.
    ''' Parmetres: Ruta i nom de l'arxiu.
    Friend Shared Function GetOnlyFileTitle(ByVal fileName As String) As String

        Dim fi As New System.IO.FileInfo(fileName)
        Return fi.Name

    End Function

    'Omplim els combobox amb les taules que hi ha a l'arxiu de la base de dades
    Friend Shared Sub OmplirCmbambTaules(ByVal Ruta As String, ByVal colTaules As Collection)
        Dim objDB As GDO.GDatabase, objTbl As GDO.GTableDef
        ' geoApp = GetObject(, "Geomedia.Application")
        objDB = CreateObject("Access.GDatabase")

        Try
            objDB.OpenDatabase(Ruta, , True) 'obrim noms de lectura
            For Each combo As System.Windows.Forms.ComboBox In colTaules
                combo.Items.Clear()
            Next combo

            For Each objTbl In objDB.GTableDefs
                For Each combo As System.Windows.Forms.ComboBox In colTaules
                    combo.Items.Add(objTbl.Name)
                    combo.SelectedItem = 0

                Next combo
            Next objTbl


        Catch
            'Si no ha pogut obrir la base de dades mostrem l'error
            MsgBox("Error a l'obrir la taula:" & Ruta, MsgBoxStyle.Critical, "Error")
        End Try

    End Sub

    Friend Shared Sub OmplirCmbArxius(ByVal Ruta As String, ByVal Controles As Collection)


        If (Ruta <> "") Then
            Dim xFile$
            xFile = Dir$(Ruta, FileAttribute.Archive)
            Do

                If xFile.Contains(".mdb") Then
                    'omplim el combobox
                    'CmbTaulaEix.Items.Add(xFile)

                    For Each Ctrl As System.Windows.Forms.ComboBox In Controles
                        Ctrl.Items.Add(Ruta & xFile)
                    Next

                End If

                xFile = Dir()
            Loop While xFile <> ""

        Else
            MsgBox("Has de triar la carpeta de les dades", MsgBoxStyle.Exclamation, "Error")

        End If

    End Sub
    Friend Shared Sub OmplirCmbColumnes(ByVal Ruta As String, ByVal Taula As String, ByVal combo As System.Windows.Forms.ComboBox)
        Dim objDB As GDO.GDatabase, objTbl As GDO.GTableDef, objFld As GDO.GField
         objDB = CreateObject("Access.GDatabase")
        Try
            combo.Items.Clear()
            objDB.OpenDatabase(Ruta, , True) 'obrim noms de lectura
            objTbl = objDB.GTableDefs(Taula)
            For Each objFld In objDB.GTableDefs(Taula).GFields
                combo.Items.Add(objFld.Name)
            Next objFld
            combo.SelectedIndex = 0
        Catch
            MsgBox("Error a l'obrir la taula:" & Ruta, MsgBoxStyle.Critical, "Error")
        End Try


    End Sub
    Friend Shared Sub OmplircolCmbColumnes(ByVal Ruta As String, ByVal Taula As String, ByVal Coleccion As Collection)
        Dim objDB As GDO.GDatabase, objTbl As GDO.GTableDef, objFld As GDO.GField
        objDB = CreateObject("Access.GDatabase")
        Try
            objDB.OpenDatabase(Ruta, , True) 'obrim noms de lectura
            objTbl = objDB.GTableDefs(Taula)
            For Each Combo As Windows.Forms.ComboBox In Coleccion
                For Each objFld In objDB.GTableDefs(Taula).GFields
                    Combo.Items.Add(objFld.Name)
                Next objFld
                Combo.SelectedIndex = 0
            Next
        Catch
            'Si no ha pogut obrir la base de dades mostrem l'error
            MsgBox("Error a l'obrir la taula:" & Ruta, MsgBoxStyle.Critical, "Error")
        End Try
    End Sub
    Friend Shared Sub AfegirNovaTaula(ByVal cmb As ComboBox, ByVal openfile As System.Windows.Forms.OpenFileDialog)
        openfile.FileName = "Tria una nova taula:"
        openfile.Filter = "Fitxer taula|*.mdb"
        openfile.ShowDialog()
        cmb.Items.Add(openfile.FileName)
    End Sub
    'Crear les taules resultants
    Friend Shared Sub crearTaula(ByVal RutaTaula As String, ByVal NomTaula As String)
        Dim objDB As GDO.GDatabase, objTbl As GDO.GTableDef
        Dim objFld As GDO.GField
        '***********************************  Fem la taula dels Carrers ************************************
        objDB = CreateObject("Access.GDatabase")
        objDB.CreateDatabase(RutaTaula & NomTaula & ".mdb", GDO.GConstants.gdbLangGeneral)
        objTbl = objDB.CreateTableDef("Pol_Carrers")        'Create table object 
        objTbl.Name = "Pol_Carrers" 'Nom de la taula
        Dim objIdx As GDO.GIndex, objIdxFld As GDO.GField        ' Create and define index on "ID" field 
        objIdx = objTbl.CreateIndex("IDidx")
        objIdxFld = objIdx.CreateField("ID1")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDidx"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With

        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing

        'Crear un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear un camp numric Per al SENTIT
        objFld = objTbl.CreateField("SENTIT", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 1
            .Name = "SENTIT"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear un camp numric Per al n de carrils
        objFld = objTbl.CreateField("CARRILS", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 1
            .Name = "CARRILS"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear  un camp de tipus nmero  per al tipus de carril PEATONAL
        objFld = objTbl.CreateField("PEATONAL", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 0
            .Name = "PEATONAL"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear i afegir un camp de tipus nmero  per al tipus de carril BICI
        objFld = objTbl.CreateField("CBICI", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 0
            .Name = "CBICI"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear el camp per a l'angle del poligon
        objFld = objTbl.CreateField("Angle", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 3
            .Name = "Angle"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing
        'Crear i afegir un camp de tipus nmero  per al tipus de carril BICI
        objFld = objTbl.CreateField("Quadrant", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 0
            .Name = "Quadrant"
            .Required = False
        End With


        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Crear un camp numric Per a l'Amplada del carril
        objFld = objTbl.CreateField("AMPLADA", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 3
            .Name = "AMPLADA"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crea un camp  per al centroide
        objFld = objTbl.CreateField("Centroide", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("ID1", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Create, define, and append geometry field 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing
        'Afegim la taula
        objDB.GTableDefs.Append(objTbl)
        objTbl = Nothing

        ' *********************** Fem la taula de separadors de carrils ***************************************
        objTbl = objDB.CreateTableDef("Linia_Carrils")
        objTbl.Name = "Separacio_Carrils"

        ' Create and define index on "ID" field 
        objIdx = objTbl.CreateIndex("IDidx")
        objIdxFld = objIdx.CreateField("ID")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDidx"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With
        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing

        'Crear un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear un camp numric per al nombre de carrils
        objFld = objTbl.CreateField("CARRILS", GDO.GConstants.gdbInteger)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 1
            .Name = "CARRILS"
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear un camp numric per al tipus peatonal
        objFld = objTbl.CreateField("PEATONAL", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 0
            .Name = "PEATONAL"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear i afegir un camp de tipus nmero  per al tipus de carril BICI
        objFld = objTbl.CreateField("CBICI", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 0
            .Name = "CBICI"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear un camp numric Per a l'Amplada del carril
        objFld = objTbl.CreateField("AMPLADA", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 3
            .Name = "AMPLADA"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("ID", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Create, define, and append geometry field 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbLinear
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing
        objDB.GTableDefs.Append(objTbl)
        objTbl = Nothing

        ' *********************** Fem la taula dels carrils Bici ***************************************


        objTbl = objDB.CreateTableDef("Carrils_Bici")
        objTbl.Name = "Carrils_Bici"

        ' Create and define index on "ID" field 
        objIdx = objTbl.CreateIndex("IDBici")
        objIdxFld = objIdx.CreateField("IDB")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDBici"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With
        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing

        'Crear un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("IDB", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels carrils 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels centroides 
        objFld = objTbl.CreateField("Centroide", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        objDB.GTableDefs.Append(objTbl)


        ' *********************** Fem la taula dels carrils Peatonals ***************************************

        objTbl = objDB.CreateTableDef("Carrils_Peatonals")
        objTbl.Name = "Carrils_Peatonals"

        ' Create and define index on "ID" field 
        objIdx = objTbl.CreateIndex("IDPeat")
        objIdxFld = objIdx.CreateField("IDP")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDPeaat"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With
        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing

        'Crear un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("IDP", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels carrils 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels centroides 
        objFld = objTbl.CreateField("Centroide", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        objDB.GTableDefs.Append(objTbl)


        ' *********************** Fem la taula dels carrils  ***************************************


        objTbl = objDB.CreateTableDef("Carrils")
        objTbl.Name = "Carrils"

        ' Create and define index on "ID" field 
        objIdx = objTbl.CreateIndex("IDCarr")
        objIdxFld = objIdx.CreateField("IDCar")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing
        With objIdx
            .Name = "IDCarr"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With
        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing

        'Crear un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("IDCar", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels carrils 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing
        'Creem un camp per a la geometria dels centroides 
        objFld = objTbl.CreateField("Centroide", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            '.SubType = GDO.GConstants.gdbLinear
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing
        objDB.GTableDefs.Append(objTbl)


        ' *********************** Fem la taula dels carrils Bus ***************************************


        objTbl = objDB.CreateTableDef("Carrils_Bus")
        objTbl.Name = "Carrils_Bus"

        ' Create and define index on "ID" field 
        objIdx = objTbl.CreateIndex("IDBUS")
        objIdxFld = objIdx.CreateField("IDBs")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDBUS"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With
        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing

        'Crear un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("IDBs", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels carrils 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels centroides 
        objFld = objTbl.CreateField("Centroide", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing
        objDB.GTableDefs.Append(objTbl)


        ' *********************** Fem la taula dels Nodes  ***************************************


        objTbl = objDB.CreateTableDef("Nodes")
        objTbl.Name = "Nodes"

        ' Create and define index on "ID" field 
        objIdx = objTbl.CreateIndex("IDN")
        objIdxFld = objIdx.CreateField("IDN")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDN"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With
        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing

        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("IDN", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing
        objDB.GTableDefs.Append(objTbl)

        'Treiem el capturador per a poder recuperar l'error des d'on l'hem cridat
        'Catch ex As Exception

        'MsgBox(ex.Message, MsgBoxStyle.Exclamation, )


        'End Try




    End Sub


  

    Friend Shared Sub crearPoligonsCarrers(ByVal config As configuracio, ByVal ProgressBar1 As ToolStripProgressBar, ByVal RutaSortida As String, ByVal arxiuSortida As String, ByVal form1 As Form)

        Dim objGSS As New PClient.GeometryStorageServiceClass, rsr As GDO.GRecordset, rsw As GDO.GRecordset, rsAmplada As GDO.GRecordset
        Dim Geomt As Object, pnt As New PBasic.point, pntInit As New PBasic.point
        Dim pntFi As New PBasic.point
        Dim cnk As Object, rutabd As String, sql As String, rutabd2 As String
        Dim Gpoly As PBasic.PolygonGeometryClass, GPolyLine As PBasic.PolylineGeometry
        Dim leftOffset As New PBasic.PolylineGeometry, rightOffset As New PBasic.PolylineGeometry
        Dim auxBol As Boolean, nPunt As Integer, pntIni As PBasic.point
        Dim oriPnt As PBasic.OrientedPointGeometry = New PBasic.OrientedPointGeometry
        Dim objDB As GDO.GDatabase
        Dim objDB2 As GDO.GDatabase
        Dim nQuadrant As Integer
        Dim mAngle As Double


        objDB = CreateObject("Access.GDatabase")
        objDB2 = CreateObject("Access.GDatabase")
        rutabd = config.clCarrer.Arxiu
        rutabd2 = RutaSortida & arxiuSortida & ".mdb"
        Try 'Obrim la base de dades amb les dades inicials
            objDB.OpenDatabase(rutabd, , True)
        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd = (InputBox("Ruta de la base de dades d'entrada: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd)
        End Try
        Try 'Obrim la base de dades de sortida
            objDB2.OpenDatabase(rutabd2)
        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd2 = (InputBox("Ruta de la base de dades de sortida: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd2)
        End Try
        'Recompte del nombre de nodes
        sql = "select * from " & config.clCarrer.Taula
        rsr = objDB.OpenRecordset(sql, GDO.GConstants.gdbOpenDynaset)
        rsw = objDB2.OpenRecordset("select * from Pol_Carrers", GDO.GConstants.gdbOpenDynaset)

        Dim j As Integer
        j = 0
        ProgressBar1.Value = 0

        'Recorrem la taula
        While Not rsr.EOF
            With ProgressBar1 'iniciem a 0 el progressbar
                .Maximum = rsr.RecordCount()
                .Minimum = 0
            End With
            objGSS.GetGeometry(rsr.GFields("Geometry"), Geomt)
            If Geomt.Type = "PolylineGeometry" Then 'si es una polilnia
                'Busquem l'amplada dels carrils a l'altra taula
                rsAmplada = objDB.OpenRecordset("select * from " & config.clAmplada.Taula & " Where " & config.clCarrer.Camp & "=" & rsr.GFields(config.clCarrer.Camp).Value, GDO.GConstants.gdbOpenDynaset)


                pntInit.X = Geomt.Points(1).x
                pntInit.Y = Geomt.Points(1).y
                pntFi.X = Geomt.Points(2).x
                pntFi.Y = Geomt.Points(2).y


                Gpoly = New PBasic.PolygonGeometryClass
                GPolyLine = New PBasic.PolylineGeometry
                '******************************************************************************************************************

                '******************************************************************************************************************
                Dim Ample As Double
                Dim fn As Funcions = New Funcions
                Dim intSentit As Integer

                'Si no hi ha info de l'amplada posem 3
                Try 'Mirem si hi ha informacio de l'amplada o si el carril est a la taula trams
                    'en cas de no ser-hi rsAmplada donar error al estar buit

                    Ample = rsr.GFields(config.clCarrils.Camp).Value * rsAmplada.GFields(config.clAmplada.Camp).Value
                    intSentit = rsAmplada.GFields(config.clSentit.Camp).Value

                Catch
                    'Si no hi ha informacio de l'amplada possem 3
                    Ample = rsr.GFields(config.clCarrils.Camp).Value * 3
                End Try

                'Fem la paralela    
                rightOffset = New PBasic.PolylineGeometry
                leftOffset = New PBasic.PolylineGeometry
                auxBol = fn.Paralela1(Geomt, Ample / 2, rightOffset, leftOffset)
                Gpoly = fn.crearPoligon(rightOffset, leftOffset)

                rsw.AddNew()
                objGSS.GeometryToStorage(Gpoly, cnk)

                With rsw 'Guardem les dades
                    Try

                        .GFields("AMPLADA").Value = rsAmplada.GFields(3).Value
                    Catch
                        'Si no hi ha informacio de l'amplada possem 3
                        .GFields("AMPLADA").Value = 3
                    End Try
                    .GFields("IDTRAM").Value = rsr.GFields(config.clCarrer.Camp).Value
                    'TIPUS
                    .GFields("PEATONAL").Value = rsr.GFields(config.clPeatonal.Camp).Value
                    .GFields("CARRILS").Value = rsr.GFields(config.clCarrils.Camp).Value
                    .GFields("CBICI").Value = rsr.GFields(config.clBici.Camp).Value
                    .GFields("SENTIT").Value = intSentit 'rsAmplada.GFields(config.clSentit.Camp).Value
                    .GFields("Geometry").Value = cnk
                    'punt del mig, s'utilitza aquesta opci pel fet que no ha funcionat centerpoint de Geomedia
                    nPunt = Geomt.Points.Count \ 2
                    pntIni = Geomt.Points(nPunt)
                    pntFi = Geomt.Points(nPunt + 1)

                    Dim GeomBlob As Object
                    'Guardem el punt del mmig
                    objGSS = New PClient.GeometryStorageService
                    GeomBlob = New Object
                    oriPnt.Origin.X = (pntIni.X + pntFi.X) / 2
                    oriPnt.Origin.Y = (pntIni.Y + pntFi.Y) / 2
                    nQuadrant = calcularQuadrant(pntIni, pntFi)
                    .GFields("Quadrant").Value = nQuadrant


                    If intSentit = 1 Then 'SI ES EN SENTIT CONTRARI sumem Pi a l'angle
                        mAngle = CalcularAngle(pntIni, pntFi) + Math.PI

                    Else
                        mAngle = CalcularAngle(pntIni, pntFi)

                    End If

                    'Si es bici o peatonal el desplacem
                    If rsr.GFields(config.clPeatonal.Camp).Value = 1 Or rsr.GFields(config.clBici.Camp).Value = 1 Then
                        oriPnt = Funcions.desplaarPunt(oriPnt, mAngle, 5)
                    End If
                    'Triem la orientaci
                    With oriPnt
                        .Orientation.I = Math.Cos(mAngle)
                        .Orientation.J = Math.Sin(mAngle)
                        .Orientation.K = 0
                    End With
                    'Mirem el quadrant de l'angle
                    Select Case nQuadrant

                        Case 2 'el sinus dels angles suplementaris donen el mateix valor,`pero el gir es diferent
                            oriPnt.Orientation.J = -oriPnt.Orientation.J
                            oriPnt.Orientation.I = -oriPnt.Orientation.I

                        Case 3
                            oriPnt.Orientation.J = -oriPnt.Orientation.J
                            oriPnt.Orientation.I = -oriPnt.Orientation.I
                    End Select
                    '''''''''''''''''''''''''''''''''''''''
                    objGSS.GeometryToStorage(oriPnt, GeomBlob)
                    .GFields("Centroide").Value = GeomBlob
                    .GFields("Angle").Value = mAngle
                    .Update()
                    Gpoly = Nothing
                    Geomt = New Object

                End With

            End If
            rsr.MoveNext()
            ProgressBar1.Value = j
            form1.Refresh()
            j = j + 1
            form1.Refresh()
        End While
        objGSS = Nothing
        rsr = Nothing
        rsw = Nothing
        objDB.Close()
        objDB2.Close()


    End Sub
    Friend Shared Sub crearPoligonsTipus(ByVal Tipus As String, ByVal Camp As String, ByVal config As configuracio, ByVal ProgressBar1 As ToolStripProgressBar, ByVal RutaSortida As String, ByVal arxiuSortida As String, ByVal form1 As Form)
        

        Dim objGSS As New PClient.GeometryStorageServiceClass, rsw As GDO.GRecordset, rsAmplada As GDO.GRecordset
        Dim Geomt As Object, pnt As New PBasic.point, pntInit As New PBasic.point
        Dim pntCentre As New PBasic.PolylineGeometry
        Dim cnk As Object, nCarrils As Integer, sql As String
        Dim Gpoly As PBasic.PolygonGeometryClass
        Dim Gpoly2 As PBasic.PolygonGeometryClass
        Dim oriPnt As PBasic.OrientedPointGeometry = New PBasic.OrientedPointGeometry
        Dim leftOffset As New PBasic.PolylineGeometry, rightOffset As New PBasic.PolylineGeometry
        Dim leftOffset2 As New PBasic.PolylineGeometry, rightOffset2 As New PBasic.PolylineGeometry
        Dim pntIni As PBasic.point, pntFi As PBasic.point

        Dim auxBol As Boolean, Ample As Double, contador As Integer

        Dim rsr As GDO.GRecordset

        Dim rutabd As String, rutabd2 As String


        Dim objDB As GDO.GDatabase
        Dim objDB2 As GDO.GDatabase

        objDB = CreateObject("Access.GDatabase")
        objDB2 = CreateObject("Access.GDatabase")

        rutabd = config.clCarrer.Arxiu
        rutabd2 = RutaSortida & arxiuSortida & ".mdb"



        Try

            objDB.OpenDatabase(rutabd, , True)
        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd = (InputBox("Ruta de la base de dades d'entrada: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd)
        End Try
        Try


            objDB2.OpenDatabase(rutabd2)

        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd2 = (InputBox("Ruta de la base de dades de sortida: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd2)
        End Try

        sql = "select * from " & config.clCarrer.Taula
        rsr = objDB.OpenRecordset(sql, GDO.GConstants.gdbOpenDynaset)

        sql = "select * from " & Tipus
        rsw = objDB2.OpenRecordset(sql, GDO.GConstants.gdbOpenDynaset)

        Dim l As Integer
        l = 0
        ProgressBar1.Value = 0
        'Recorrem la taula


        With oriPnt
            .Orientation.I = 1
            .Orientation.J = 0
            .Orientation.K = 0
        End With
        While Not rsr.EOF

            With ProgressBar1
                .Maximum = rsr.RecordCount()
                .Minimum = 0
            End With

            objGSS.GetGeometry(rsr.GFields("Geometry"), Geomt)
            If rsr.GFields(Camp).Value > 0 Then 'si es carril bici, o peatonal, tindr un 1 en el camp, per a fer tots els carrils se li pasa com a camp el ID que mai tindr 0 i els far tots
                Try
                    'Mirem l'amplada del carril
                    rsAmplada = objDB.OpenRecordset("select * from " & config.clAmplada.Taula & " Where IDTRAM=" & rsr.GFields(config.clCarrer.Camp).Value, GDO.GConstants.gdbOpenDynaset)
                    Ample = rsAmplada.GFields(3).Value
                Catch
                    'Si no hi ha informacio de l'amplada possem 3
                    Ample = 3
                End Try
                'nombre de carrils
                nCarrils = rsr.GFields(config.clCarrils.Camp).Value

                Dim fn As Funcions = New Funcions
                Dim npunt As Integer
                rightOffset = New PBasic.PolylineGeometry
                leftOffset = New PBasic.PolylineGeometry
                'fem les paral a la distancia corresponent depenent de si el nombre de carrils es parell o no
                If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                    'Si el nombre de carrils es parell:
                    auxBol = fn.Paralela1(Geomt, Ample, rightOffset, leftOffset)
                    Gpoly = fn.crearPoligon(rightOffset, Geomt)
                Else
                    auxBol = fn.Paralela1(Geomt, Ample / 2, rightOffset, leftOffset)
                    Gpoly = fn.crearPoligon(rightOffset, leftOffset)
                End If
                'Guardem el poligon
                objGSS = New PClient.GeometryStorageServiceClass
                cnk = New Object
                objGSS.GeometryToStorage(Gpoly, cnk)

                With rsw
                    .AddNew()
                    .GFields("IDTRAM").Value = rsr.GFields(config.clCarrer.Camp).Value
                    .GFields("Geometry").Value = cnk
                    'punt del mig
                    npunt = Geomt.Points.Count \ 2
                    pntIni = Geomt.Points(npunt)
                    pntFi = Geomt.Points(npunt + 1)
                    Dim pntAux As New PBasic.point
                    pntAux.X = (pntIni.X + pntFi.X) / 2
                    pntAux.Y = (pntIni.Y + pntFi.Y) / 2
                    Dim GeomBlob As Object
                    'Guardem el punt
                    objGSS = New PClient.GeometryStorageService
                    GeomBlob = New Object
                    oriPnt.Origin.X = pntAux.X
                    oriPnt.Origin.Y = pntAux.Y
                    objGSS.GeometryToStorage(oriPnt, GeomBlob)
                    .GFields("Centroide").Value = GeomBlob
                End With
                rsw.Update()

                'Si es parell s'ha de guardar l'altre poligon
                If nCarrils Mod 2 = 0 Then

                    Gpoly = fn.crearPoligon(leftOffset, Geomt)
                    'Guardem el poligon
                    objGSS = New PClient.GeometryStorageServiceClass
                    cnk = New Object
                    objGSS.GeometryToStorage(Gpoly, cnk)
                    'Guardem el poligon
                    With rsw
                        .AddNew()
                        .GFields("IDTRAM").Value = rsr.GFields(config.clCarrer.Camp).Value
                        .GFields("Geometry").Value = cnk
                        'punt mig
                        npunt = Geomt.Points.Count \ 2
                        pntIni = Geomt.Points(npunt)
                        pntFi = Geomt.Points(npunt + 1)
                        Dim pntAux As New PBasic.point
                        pntAux.X = (pntIni.X + pntFi.X) / 2
                        pntAux.Y = (pntIni.Y + pntFi.Y) / 2
                        Dim GeomBlob As Object
                        'Guardem el punt
                        objGSS = New PClient.GeometryStorageService
                        GeomBlob = New Object
                        oriPnt.Origin.X = pntAux.X
                        oriPnt.Origin.Y = pntAux.Y
                        objGSS.GeometryToStorage(oriPnt, GeomBlob)
                        .GFields("Centroide").Value = GeomBlob
                    End With
                    rsw.Update()

                End If

                If nCarrils > 2 Then 'si hi ha ms de dos carrils
                    Dim Fita As Integer

                    If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                        Fita = nCarrils \ 2 - 1
                    Else
                        Fita = nCarrils \ 2
                    End If

                    For contador = 1 To Fita

                        If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                            'Si el nombre de carrils es parell:
                            auxBol = fn.Paralela1(Geomt, contador * Ample, rightOffset, leftOffset)
                            auxBol = fn.Paralela1(Geomt, (contador + 1) * Ample, rightOffset2, leftOffset2)


                        Else
                            auxBol = fn.Paralela1(Geomt, (contador - 1) * Ample + Ample / 2, rightOffset, leftOffset)
                            auxBol = fn.Paralela1(Geomt, contador * Ample + Ample / 2, rightOffset2, leftOffset2)
                            Gpoly = fn.crearPoligon(rightOffset, leftOffset)
                        End If

                        Gpoly = fn.crearPoligon(rightOffset, rightOffset2)
                        Gpoly2 = fn.crearPoligon(leftOffset, leftOffset2)

                        'Guardem els poligons
                        objGSS = New PClient.GeometryStorageServiceClass
                        cnk = New Object
                        objGSS.GeometryToStorage(Gpoly, cnk)

                        With rsw
                            .AddNew()
                            .GFields("IDTRAM").Value = rsr.GFields(config.clCarrer.Camp).Value
                            .GFields("Geometry").Value = cnk
                            'punt mig
                            npunt = Geomt.Points.Count \ 2

                            pntIni = Geomt.Points(npunt)
                            pntFi = Geomt.Points(npunt + 1)
                            Dim pntAux As New PBasic.point
                            pntAux.X = (pntIni.X + pntFi.X) / 2
                            pntAux.Y = (pntIni.Y + pntFi.Y) / 2
                            Dim GeomBlob As Object
                            'Guardem el punt
                            objGSS = New PClient.GeometryStorageService
                            GeomBlob = New Object
                            oriPnt.Origin.X = pntAux.X
                            oriPnt.Origin.Y = pntAux.Y
                            objGSS.GeometryToStorage(oriPnt, GeomBlob)
                            .GFields("Centroide").Value = GeomBlob

                        End With
                        rsw.Update()

                        objGSS = New PClient.GeometryStorageServiceClass
                        cnk = New Object
                        objGSS.GeometryToStorage(Gpoly2, cnk)
                        'Guardem el poligon
                        With rsw
                            .AddNew()
                            .GFields("IDTRAM").Value = rsr.GFields(config.clCarrer.Camp).Value
                            .GFields("Geometry").Value = cnk
                            'punt mig
                            npunt = Geomt.Points.Count \ 2

                            pntIni = Geomt.Points(npunt)
                            pntFi = Geomt.Points(npunt + 1)
                            Dim pntAux As New PBasic.point
                            pntAux.X = (pntIni.X + pntFi.X) / 2
                            pntAux.Y = (pntIni.Y + pntFi.Y) / 2
                            Dim GeomBlob As Object
                            'Guardem el punt
                            objGSS = New PClient.GeometryStorageService
                            GeomBlob = New Object
                            oriPnt.Origin.X = pntAux.X
                            oriPnt.Origin.Y = pntAux.Y
                            objGSS.GeometryToStorage(oriPnt, GeomBlob)
                            .GFields("Centroide").Value = GeomBlob

                        End With
                        rsw.Update()

                    Next
                End If
            End If

            l = l + 1

            ProgressBar1.Value = l
            rsr.MoveNext()

            form1.Refresh()
        End While
        objGSS = Nothing
        objDB.Close()
        objDB.Close()
        rsw.Close()

    End Sub
    Friend Shared Sub crearEixosCarrils(ByVal config As configuracio, ByVal ProgressBar1 As ToolStripProgressBar, ByVal RutaSortida As String, ByVal arxiuSortida As String, ByVal form1 As Form)


        '**********************    Fem la taula de carrils  ***************************
        Dim objGSS As New PClient.GeometryStorageServiceClass, rsr As GDO.GRecordset, rsw As GDO.GRecordset, rsAmplada As GDO.GRecordset
        Dim pnt As New PBasic.point, pntInit As New PBasic.point
        Dim pntFi As New PBasic.point
        Dim cnk As Object
        Dim Ample As Double, Linia As New PBasic.PolylineGeometry
        Dim Geomt As Object, nCarrils As Integer, Contador As Integer, IdTram As Integer
        Dim objDB As GDO.GDatabase
        Dim objDB2 As GDO.GDatabase
        objDB = CreateObject("Access.GDatabase")
        objDB2 = CreateObject("Access.GDatabase")
        Dim rutabd As String
        Dim rutabd2 As String
        Dim leftOffset As New PBasic.PolylineGeometry, rightOffset As New PBasic.PolylineGeometry
        Dim auxBol As Boolean


        rutabd = config.clCarrer.Arxiu
        rutabd2 = RutaSortida & arxiuSortida & ".mdb"
        Try

            objDB.OpenDatabase(rutabd, , True)
        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd = (InputBox("Ruta de la base de dades d'entrada: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd)
        End Try
        Try
            objDB2.OpenDatabase(rutabd2)
        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd2 = (InputBox("Ruta de la base de dades de sortida: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd2)
        End Try
        'Recompte del nombre de nodes
        Dim sql As String
        Sql = "select * from " & config.clCarrer.Taula
        rsr = objDB.OpenRecordset(Sql, GDO.GConstants.gdbOpenDynaset)
        rsw = objDB2.OpenRecordset("select * from Separacio_Carrils", GDO.GConstants.gdbOpenDynaset)

        Dim l As Integer
        Dim j As Integer
        j = 0
        l = 0

        'Recorrem la taula
        ProgressBar1.Value = 0
        While Not rsr.EOF
            With ProgressBar1
                .Maximum = rsr.RecordCount()
                .Minimum = 0
            End With

            objGSS.GetGeometry(rsr.GFields("Geometry"), Geomt)

            Try

                rsAmplada = objDB.OpenRecordset("select * from " & config.clAmplada.Taula & " Where IDTRAM=" & rsr.GFields(config.clCarrer.Camp).Value, GDO.GConstants.gdbOpenDynaset)

            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

            'Busquem l'amplada dels carrils
            Try
                Ample = rsAmplada.GFields(3).Value
            Catch ex As Exception
                'Si no hi ha informacio de l'amplada posem 3
                Ample = 3
            End Try
            'guardem el nombre de carrils
            nCarrils = rsr.GFields(config.clCarrils.Camp).Value
            If nCarrils > 1 Then ' Si noms hi ha un carril no cal fer res
                IdTram = rsr.GFields(config.clCarrer.Camp).Value
                If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                    'Si el nombre de carrils es parell:
                    'Hem de posar una lnia a l'eix del carrer
                    'Omplim la taula
                    With rsw
                        .AddNew()
                        .GFields("IDTRAM").Value = IdTram
                        .GFields("CARRILS").Value = nCarrils
                        .GFields("AMPLADA").Value = Ample
                        .GFields("PEATONAL").Value = rsr.GFields(config.clPeatonal.Camp).Value
                        .GFields("CBICI").Value = rsr.GFields(config.clBici.Camp).Value
                        .GFields("Geometry").Value = rsr.GFields("Geometry").Value
                        .Update()
                    End With
                End If

                Dim fn As Funcions = New Funcions
                Dim Fita As Integer

                If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                    Fita = nCarrils \ 2 - 1
                Else
                    Fita = nCarrils \ 2
                End If
                Dim Distancia As Double = 0
                For Contador = 1 To Fita

                    rightOffset = New PBasic.PolylineGeometry
                    leftOffset = New PBasic.PolylineGeometry

                    'Si el nombre de carrils es parell la distancia de l'eix del carrer ser multiple de l'amplada de carril
                    'si es imparell hem de comenar a 1/2 amplada
                    ' si es parell Hem de posar una lnia de separaci per costat per cada 2 carrils que afegim, 
                    'p.ex: 2 carrils noms la del mig, 4 carrils 1 a cada costat, 6 carrils 2 a cada costat -Z
                    ' Aleshores: 8 carrils=3 -> 8/2 -1, 6 carrils=2 -> 6/2 -1, 4 carrils =1 -> 4/2-1  
                    If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                        'Si el nombre de carrils es parell:
                        auxBol = fn.Paralela1(Geomt, Ample * Contador, rightOffset, leftOffset)
                    Else
                        Distancia = (Contador - 1) * Ample + Ample / 2
                        auxBol = fn.Paralela1(Geomt, Distancia, rightOffset, leftOffset)
                    End If
                    'Guardem el costat dret
                    objGSS.GeometryToStorage(rightOffset, cnk)
                    With rsw
                        .AddNew()
                        .GFields("IDTRAM").Value = IdTram
                        .GFields("CARRILS").Value = nCarrils
                        .GFields("AMPLADA").Value = Ample
                        .GFields("Geometry").Value = cnk
                        .Update()
                    End With

                    objGSS = Nothing
                    cnk = Nothing
                    objGSS = New PClient.GeometryStorageServiceClass
                    cnk = New Object
                    objGSS.GeometryToStorage(leftOffset, cnk)
                    'Guardem el costat esquerre
                    With rsw
                        .AddNew()
                        .GFields("IDTRAM").Value = IdTram
                        .GFields("CARRILS").Value = nCarrils
                        .GFields("AMPLADA").Value = Ample
                        .GFields("Geometry").Value = cnk
                        .Update()
                    End With
                Next
            End If
            l = l + 1
            rsr.MoveNext()
            ProgressBar1.Value = l
            form1.Refresh()
        End While

        objGSS = Nothing
        rsr.Close()
        rsw.Close()
        objDB.Close()
        objDB2.Close()

    End Sub
    'crea una taula amb les crlles
    Friend Shared Sub crearNodes(ByVal config As configuracio, ByVal ProgressBar1 As ToolStripProgressBar, ByVal RutaSortida As String, ByVal arxiuSortida As String, ByVal form1 As Form)


        '**********************    Fem la taula de Nodes  ***************************
        Dim objGSS As New PClient.GeometryStorageServiceClass, rsr As GDO.GRecordset, rsw As GDO.GRecordset
        Dim pnt As New PBasic.point
        Dim Geomt As Object
        Dim objDB As GDO.GDatabase
        Dim objDB2 As GDO.GDatabase
        objDB = CreateObject("Access.GDatabase")
        objDB2 = CreateObject("Access.GDatabase")
        Dim rutabd As String
        Dim rutabd2 As String

        rutabd = config.clCarrer.Arxiu
        rutabd2 = RutaSortida & arxiuSortida & ".mdb"
        Try
            objDB.OpenDatabase(rutabd, , True)
        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd = (InputBox("Ruta de la base de dades d'entrada: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd)
        End Try
        Try
            objDB2.OpenDatabase(rutabd2)
        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd2 = (InputBox("Ruta de la base de dades de sortida: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd2)
        End Try
        'Recompte del nombre de nodes
        Dim sql As String
        sql = "select * from " & config.clNodes.Taula
        rsr = objDB.OpenRecordset(sql, GDO.GConstants.gdbOpenDynaset)
        rsw = objDB2.OpenRecordset("select * from Nodes", GDO.GConstants.gdbOpenDynaset)

        Dim l As Integer
        l = 0

        'Recorrem la taula
        ProgressBar1.Value = 0
        While Not rsr.EOF
            With ProgressBar1
                .Maximum = rsr.RecordCount()
                .Minimum = 0
            End With

            objGSS.GetGeometry(rsr.GFields("Geometry"), Geomt)
            With rsw
                .AddNew()
                .GFields("Geometry").Value = rsr.GFields("Geometry").Value
                .Update()
            End With
            rsr.MoveNext()
            ProgressBar1.Value = l
            form1.Refresh()
        End While

        objGSS = Nothing
        rsr.Close()
        rsw.Close()
        objDB.Close()
        objDB2.Close()

    End Sub

    Function Paralela1(ByVal Geomt As Object, ByVal Amplada As Double, ByRef rigthOfset As PBasic.PolylineGeometry, ByRef leftOfset As PBasic.PolylineGeometry) As Boolean
        Dim PntIni As New PBasic.point
        Dim pntFi As New PBasic.point
        Dim Angle As Double, incX As Double, incY As Double
        Dim pnt0 As New PBasic.point
        Dim pnt1 As New PBasic.point
        Dim pnt2 As New PBasic.point
        Dim pnt3 As New PBasic.point
        Dim i As Integer

        rigthOfset = New PBasic.PolylineGeometry
        leftOfset = New PBasic.PolylineGeometry
        Try 'Calculem un costat
            For i = 1 To Geomt.Points.Count - 1
                'Crear Punts dels contorn a partir amplada,....
                ' Calculem l'angle
                Angle = CalcularAngle(Geomt.Points(i), Geomt.Points(i + 1))
                'Part dreta
                Angle = Angle + (Math.PI / 2)
                'un cop tenim l'angle calculem els punts
                'x = x0 + d * cos(Angle)
                pnt1.X = Geomt.Points(i).x + (Amplada * Math.Cos(Angle))
                'y=y0 + d * sin (Angle)
                pnt1.Y = Geomt.Points(i).y + (Amplada * Math.Sin(Angle))
                leftOfset.Points.Add(pnt1)
            Next
            'Calculem els increments
            incY = Geomt.Points(Geomt.Points.Count).Y - Geomt.Points(Geomt.Points.Count - 1).Y
            incX = Geomt.Points(Geomt.Points.Count).x - Geomt.Points(Geomt.Points.Count - 1).x
            'Fem l'ltim punt:
            pnt1.X = pnt1.X + incX
            pnt1.Y = pnt1.Y + incY
            leftOfset.Points.Add(pnt1)
            For i = 1 To Geomt.Points.Count - 1 'calculem l'altra paralela
                'Crear Punts dels contorn a partir amplada,....
                ' Calculem l'angle
                Angle = CalcularAngle(Geomt.Points(i), Geomt.Points(i + 1))
                Angle = Angle - (Math.PI / 2)
                'un cop tenim l'angle calculem els punts
                'x = x0 + d * cos(Angle)
                pnt1.X = Geomt.Points(i).x + (Amplada * Math.Cos(Angle))
                'y=y0 + d * sin (Angle)
                pnt1.Y = Geomt.Points(i).y + (Amplada * Math.Sin(Angle))
                rigthOfset.Points.Add(pnt1)

            Next

            ' L'ultim punt
            'Calculem els increments
            incY = Geomt.Points(Geomt.Points.Count).Y - Geomt.Points(Geomt.Points.Count - 1).Y
            incX = Geomt.Points(Geomt.Points.Count).x - Geomt.Points(Geomt.Points.Count - 1).x

            'Fem l'ltim punt:
            pnt1.X = pnt1.X + incX
            pnt1.Y = pnt1.Y + incY
            rigthOfset.Points.Add(pnt1)

            Return True

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
            Return False
        End Try
    End Function
    Friend Shared Function CalcularAngle(ByVal pnt1 As PBasic.point, ByVal pnt2 As PBasic.point) As Double
        Dim incX As Double
        Dim incY As Double
        'calculem els increments
        incY = pnt2.Y - pnt1.Y
        incX = pnt2.X - pnt1.X

        If incX = 0 Then 'si es 0 donar error div/0, equival a 90
            If incY > 0 Then
                CalcularAngle = Math.PI / 2
            Else
                CalcularAngle = -(Math.PI / 2)
            End If

        Else
            CalcularAngle = Math.Atan(Math.Abs(pnt2.Y - pnt1.Y) / Math.Abs(pnt2.X - pnt1.X))
        End If

        If incX < 0 And incY > 0 Then CalcularAngle = -CalcularAngle + Math.PI

        If incX < 0 And incY < 0 Then CalcularAngle = CalcularAngle + Math.PI

        If incX > 0 And incY < 0 Then CalcularAngle = -CalcularAngle

        Return CalcularAngle
    End Function
    Function crearPoligon(ByVal rigthPolyLine, ByVal leftPolyLine) As PBasic.PolygonGeometry
        Dim i As Integer
        Dim Poly As New PBasic.PolygonGeometry
        For i = 1 To rigthPolyLine.Points.Count

            Poly.Points.Add(rigthPolyLine.Points.Item(i))
        Next
        ' costat esquerre
        For i = leftPolyLine.Points.Count To 1 Step -1
            Poly.Points.Add(leftPolyLine.Points.Item(i))
        Next
        'Posem el darrer al principi
        Poly.Points.Add(Poly.Points.Item(1))
        Return Poly

    End Function
    Friend Shared Function calcularQuadrant(ByVal pntIni As PBasic.point, ByVal pntFi As PBasic.point) As Integer
        Dim incX As Double
        Dim incY As Double
        Dim Quadrant As Integer
        incX = pntFi.X - pntIni.X
        incY = pntFi.Y - pntIni.Y

        If incX < 0 Then
            If incY > 0 Then
                Quadrant = 2
            Else
                Quadrant = 3
            End If
        Else
            If incY > 0 Then
                Quadrant = 1
            Else
                Quadrant = 4
            End If
        End If

        Return Quadrant
    End Function
    Friend Shared Function desplaarPunt(ByVal pntDesp As PBasic.OrientedPointGeometry, ByVal angle As Double, ByVal Distancia As Double) As PBasic.OrientedPointGeometry
        'x = x0 + d * cos(Angle)
        pntDesp.Origin.X = pntDesp.Origin.X + Distancia * Math.Cos(angle)
        'y=y0 + d * sin (Angle)
        pntDesp.Origin.Y = pntDesp.Origin.Y + Distancia * Math.Sin(angle)
        Return pntDesp
    End Function
End Class